﻿
function OnVaxChatTypingTimerTick() 
{
    m_objVaxChat.OnTypingTimerTick();
}

// Class cVaxChat

function cVaxChat()
{
    var m_bTyping = false;
    var m_nTimerTyping = 0;

    this.OnVaxInit = function ()
    {	
	    ComboMyChatStatus.options[1] = new Option("Offline", 1);
        ComboMyChatStatus.options[0] = new Option("Online", 0);
        ComboMyChatStatus.options[2] = new Option("Away", 2);
        ComboMyChatStatus.options[3] = new Option("On the phone", 3);
        ComboMyChatStatus.options[4] = new Option("Busy", 4);
    }

    this.OnVaxUnInit = function ()
    {
        ListChatLog.value = "";
        
        clearTimeout(m_nTimerTyping);
        EditUserTypingMsg.value = "";
    }

    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    this.BtnChatAddContact_onclick = function()
    {
		if(EditEnterChatContact.value == "")
		return;
		
		m_objVaxFuncSIP.ChatAddContact(EditEnterChatContact.value, true);
		
        ListChatContact.options[ListChatContact.options.length] = new Option(EditEnterChatContact.value, EditEnterChatContact.value);

        if (ListChatContact.selectedIndex == -1)
            ListChatContact.selectedIndex = 0;

        EditEnterChatContact.value = "";
    }

    this.BtnChatRemoveContact_onclick = function()
    {
        if (ListChatContact.selectedIndex == -1) return;

        if (!m_objVaxFuncSIP.ChatRemoveContact(ListChatContact.options[ListChatContact.selectedIndex].value))
        {
            return;
        }

        ListChatContact.remove(ListChatContact.selectedIndex);
    }

    this.ComboMyChatStatus_onchange = function ()
    {	
		var nSelectedIndex = ComboMyChatStatus.options[ComboMyChatStatus.selectedIndex].value;
		
        if (ComboMyChatStatus.selectedIndex == -1) return;

		m_objVaxFuncSIP.ChatSetMyStatus(nSelectedIndex);
    } 

    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    this.BtnSendChatMsg_onclick = function ()
    {
        if (EditSendMsgUserName.value.length == 0)
        { 
            ShowDialog("Enter the user name");
            return;
        }

        if (!m_objVaxFuncSIP.ChatSendMessageText(EditSendMsgUserName.value, EditSendMsgText.value, 101, 0))
        {
            return;
        }

        AddToChatTextList("Me: " + EditSendMsgText.value);
        EditSendMsgText.value = "";
    }

    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    this.ChatSendMessageTyping_onkeydown = function () 
    {
        m_objVaxFuncSIP.ChatSendMessageTyping(EditSendMsgUserName.value, 0);
    }

    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    this.OnTypingTimerTick = function () 
    {
        if (m_bTyping) 
        {
            m_bTyping = false;

            clearTimeout(m_nTimerTyping);
            m_nTimerTyping = setTimeout("OnVaxChatTypingTimerTick()", 2000);
        }
        else 
        {
            this.OnChatRecvMsgTypingStop();
        }
    }

    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    function GetStatusText(StatusId)
    {	
        var Status = "";

        switch (StatusId)
        {
            case 0:
                Status = "Online";
                break;

            case 1:
                Status = "Offline";
                break;

            case 2:
                Status = "Away";
                break;

            case 3:
                Status = "On the phone";
                break;

            case 4:
                Status = "Busy";
                break;
        }

        return Status;
    }

    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////
    
    function AddToChatTextList(value) 
    {
        if (ListTextMessages.value.length == 0)
            ListTextMessages.value = ListTextMessages.value + value;
        else
            ListTextMessages.value = ListTextMessages.value + "\n" + value;

        ListTextMessages.scrollTop = ListTextMessages.scrollHeight;
    }

    function AddToChatLogList(value)
    {
        if (ListChatLog.value.length == 0)
            ListChatLog.value = ListChatLog.value + value;
        else
            ListChatLog.value = ListChatLog.value + "\n" + value;

        ListChatLog.scrollTop = ListChatLog.scrollHeight;
    }

    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    this.BtnClearChatLog_onclick = function ()
    {
        ListChatLog.value = "";
    }
    
    this.BtnClearTextMsgs_onclick = function ()
    {
        ListTextMessages.value = "";
    }

    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    this.OnChatContactStatus = function (UserName, StatusId)
    {	
        for (ContactCount = 0; ContactCount < ListChatContact.length; ContactCount++)
        {
            var ChatContact = ListChatContact.options[ContactCount].text.toUpperCase();

            if (ChatContact.indexOf(UserName.toUpperCase()) != -1)
            {
                ListChatContact.options[ContactCount].text = UserName + " [" + GetStatusText(StatusId) + "]";
            }
        }
    }

    this.OnChatSendMsgTextSuccess = function (UserName, MsgText, UserValue32bit)
    {
        AddToChatLogList("Send Message to " + UserName + " Success");
    }

    this.OnChatSendMsgTextFail = function (UserName, StatusCode, sReasonPhrase, MsgText, UserValue32bit)
    {
        AddToChatLogList("Send Message to " + UserName + " Failed");
    }

    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    this.OnChatSendMsgTypingSuccess = function (UserName, UserValue32bit)
    {
    }

    this.OnChatSendMsgTypingFail = function (UserName, StatusCode, ReasonPhrase, UserValue32bit)
    {
    }

    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    this.OnChatRecvMsgText = function (UserName, MsgText)
    {
        var nStart = MsgText.indexOf(">");

        if (nStart == -1)
        {
            AddToChatTextList(UserName + ": " + MsgText);
            return;
        }

        /* Remote softphone is sending HTML based text messages */

        nStart = nStart + 1;
        var nEnd = MsgText.indexOf("<", nStart);

        AddToChatTextList(UserName + ": " + MsgText.substr(nStart, nEnd - nStart));
    }

    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    this.OnChatRecvMsgTypingStart = function (UserName)
    {
        EditUserTypingMsg.value = UserName + " is typing a message";

        m_bTyping = true;
        this.OnTypingTimerTick();
    }

    this.OnChatRecvMsgTypingStop = function ()
    {
        EditUserTypingMsg.value = "";
    }

    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

};