﻿// Class cVaxPhoneTone

function cVaxPhoneTone()
{
    CheckPlayDialTone.checked = true;
    CheckPlayRingTone.checked = true;

    SIP_RESPONSE_RINGING = 180;
    SIP_RESPONSE_SESSION_PROGRESS = 183;

    this.OnVaxInit = function ()
    {
        
    }

    this.OnVaxUnInit = function () 
    {
        PlayStopDialTone();
        PlayStopRingTone();
    }

    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////
    
    function PlayStartDialTone()
    {
        DialToneSound.src = MediaFile.src;
    }

    function PlayStopDialTone()
    {
        DialToneSound.src = "";
    }

    function PlayStartRingTone() 
    {
        RingToneSound.src = MediaFile.src;
    }

    function PlayStopRingTone() 
    {
        RingToneSound.src = "";
    }

    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////

    this.CheckPlayDialTone_onclick = function () 
    {
        if (!CheckPlayDialTone.checked)
            PlayStopDialTone();
    }

    this.CheckPlayRingTone_onclick = function () 
    {
        if (!CheckPlayRingTone.checked)
            PlayStopMediaFile();
    }

    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////

    function StartDialTone() 
    {
        if (CheckPlayDialTone.checked)
            PlayStartDialTone();
    }

    function StopDialTone() 
    {
        PlayStopDialTone();
    }

    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////

    function StartRingTone() 
    {
        if (CheckPlayRingTone.checked)
            PlayStartRingTone();
    }

    function StopRingTone() 
    {
        PlayStopRingTone();
    }

    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////

    this.OnProvisionalResponse = function (LineNo, StatusCode) 
    {
        if (StatusCode == SIP_RESPONSE_RINGING)  // SIP response ringing
            StartDialTone();

        else if (StatusCode == SIP_RESPONSE_SESSION_PROGRESS) // SIP Server supports dial-tone media stream.
            StopDialTone();
    }

    this.OnFailureResponse = function () 
    {
        StopDialTone();
    }

    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////

    this.OnFailToConnect = function ()
    {
        StopDialTone();
    }

    this.OnLineConnected = function () 
    {
        StopDialTone();
    }

    this.OnLineDisconnected = function () 
    {
        StopDialTone();
    }

    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////

    this.OnIncomingCallAccepted = function () 
    {
        StopRingTone();
    }

    this.OnIncomingCallRejected = function () 
    {
        StopRingTone();
    }

    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////

    this.OnIncomingCallRingingStart = function () 
    {
        StartRingTone();
    }

    this.OnIncomingCallRingingStop = function () 
    {
        StopRingTone();
    }

    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////

};