﻿
Public Class MainForm

    Private m_bServerStarted As Boolean = False
    Private m_objServerWebRTC As cVaxServerWebRTCEx = Nothing

    Public Sub New()

        InitializeComponent()

        m_objServerWebRTC = New cVaxServerWebRTCEx()
        m_objServerWebRTC.m_objMainForm = Me

    End Sub

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ComboAddListenIP()

    End Sub

    Private Sub BtnStartServer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnStartServer.Click

        If m_bServerStarted = True Then
            BtnStartServer.Text = "Start VaxServerWebRTC"
            m_bServerStarted = False
            m_objServerWebRTC.UnInitialize()
            Return
        End If

        Dim sListenIP As String = ComboGetSelectedListenIP()
        If sListenIP.Length = 0 Then Return

        If Not m_objServerWebRTC.Initialize(sListenIP, Integer.Parse(EditListenPort.Text), "", "", "") Then Return

        m_objServerWebRTC.SetListenPortRangeRTP(40000, 44000, 46000, 50000)

        Dim sWebSocketURL As String = m_objServerWebRTC.BuildWebSocketURL()
        If sWebSocketURL.Length = 0 Then Return

        EditServerURL.Text = sWebSocketURL

        BtnStartServer.Text = "Stop VaxServerWebRTC"
        m_bServerStarted = True

    End Sub

    Private Sub BtnCopyUrl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCopyUrl.Click
        Clipboard.SetText(EditServerURL.Text)
    End Sub

    Private Sub BtnCopyUrlDemo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCopyUrlDemo.Click
        Clipboard.SetText(EditDemoURL.Text)
    End Sub

    Private Sub ComboAddListenIP()

        m_objServerWebRTC.GetStartListenIP()

        While True

            Dim sListenIP As String = m_objServerWebRTC.GetNextListenIP()
            If sListenIP.Length = 0 Then Exit While
            ComboListenIP.Items.Add(sListenIP)

        End While

        If ComboListenIP.Items.Count <> 0 Then ComboListenIP.SelectedIndex = 0

    End Sub

    Private Function ComboGetSelectedListenIP() As String

        Dim nSelectedIndex As Integer = ComboListenIP.SelectedIndex
        If nSelectedIndex = -1 Then Return ""
        Return CType(ComboListenIP.Items(nSelectedIndex), String)

    End Function

    Public Sub OnVaxErrorMsg(ByVal sFuncName As String, ByVal sErrorMsg As String, ByVal nErrorCode As Integer)
        MessageBox.Show(sErrorMsg, "VaxVoIP SIP SDK", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
    End Sub

End Class
