﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ServerWebRTC
{
    public partial class MainForm : Form
    {
        private Boolean m_bServerStarted = false;
        private cVaxServerWebRTCEx m_objServerWebRTC = null;

        public MainForm()
        {
            InitializeComponent();

            m_objServerWebRTC = new cVaxServerWebRTCEx();
            m_objServerWebRTC.m_objMainForm = this;
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            ComboAddListenIP();
        }

        private void BtnStartServer_Click(object sender, EventArgs e)
        {
            if (m_bServerStarted == true)
            {
                BtnStartServer.Text = "Start VaxServerWebRTC";    
                m_bServerStarted = false;

                m_objServerWebRTC.UnInitialize();
                return;
            }

            String sListenIP = ComboGetSelectedListenIP();
            if (sListenIP.Length == 0) return;

            if (!m_objServerWebRTC.Initialize(sListenIP, int.Parse(EditListenPort.Text), "", "", ""))
                return;

            m_objServerWebRTC.SetListenPortRangeRTP(40000, 44000, 46000, 50000);

            string sWebSocketURL = m_objServerWebRTC.BuildWebSocketURL();
            if (sWebSocketURL.Length == 0) return;

            EditServerURL.Text = sWebSocketURL;

            BtnStartServer.Text = "Stop VaxServerWebRTC";
            m_bServerStarted = true;   
        }

        private void BtnCopyUrl_Click(object sender, EventArgs e)
        {
            Clipboard.SetText(EditServerURL.Text);
        }

        private void BtnCopyUrlDemo_Click(object sender, EventArgs e)
        {
            Clipboard.SetText(EditDemoURL.Text);
        }

        private void ComboAddListenIP()
        {
            m_objServerWebRTC.GetStartListenIP();

            while (true)
            {
                String sListenIP = m_objServerWebRTC.GetNextListenIP();
                if (sListenIP.Length == 0) break;

                ComboListenIP.Items.Add(sListenIP);
            }

            if (ComboListenIP.Items.Count != 0)
                ComboListenIP.SelectedIndex = 0;
        }

        private String ComboGetSelectedListenIP()
        {
            int nSelectedIndex = ComboListenIP.SelectedIndex;
            
            if (nSelectedIndex == -1)
                return "";

            return (String) ComboListenIP.Items[nSelectedIndex];
        }

        public void OnVaxErrorMsg(String sFuncName, String sErrorMsg, int nErrorCode)
        {
            MessageBox.Show(sErrorMsg, "VaxVoIP SIP SDK", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }
    }
}
