﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ServerWebRTC
{
    public partial class MainWindow : Window
    {
        private Boolean m_bServerStarted = false;
        private cVaxServerWebRTCEx m_objServerWebRTC = null;

        public MainWindow()
        {
            InitializeComponent();

            m_objServerWebRTC = new cVaxServerWebRTCEx();
            m_objServerWebRTC.m_objMainWnd = this; 
        }

        private void MainForm_Loaded(object sender, RoutedEventArgs e)
        {
            ComboAddListenIP();
        }

        private void BtnStartServer_Click(object sender, EventArgs e)
        {
            if (m_bServerStarted == true)
            {
                BtnStartServer.Content = "Start VaxServerWebRTC";
                m_bServerStarted = false;

                m_objServerWebRTC.UnInitialize();
                return;
            }

            String sListenIP = ComboGetSelectedListenIP();
            if (sListenIP.Length == 0) return;

            if (!m_objServerWebRTC.Initialize(sListenIP, int.Parse(EditListenPort.Text), "", "", ""))
                return;

            m_objServerWebRTC.SetListenPortRangeRTP(40000, 44000, 46000, 50000);

            string sWebSocketURL = m_objServerWebRTC.BuildWebSocketURL();
            if (sWebSocketURL.Length == 0) return;

            EditServerURL.Text = sWebSocketURL;

            BtnStartServer.Content = "Stop VaxServerWebRTC";
            m_bServerStarted = true;   
        }

        private void BtnCopyUrl_Click(object sender, RoutedEventArgs e)
        {
            Clipboard.SetText(EditServerURL.Text);
        }

        private void BtnCopyUrlDemo_Click(object sender, RoutedEventArgs e)
        {
            Clipboard.SetText(EditDemoURL.Text);
        }

        private void ComboAddListenIP()
        {
            m_objServerWebRTC.GetStartListenIP();

            while (true)
            {
                String sListenIP = m_objServerWebRTC.GetNextListenIP();
                if (sListenIP.Length == 0) break;

                ComboListenIP.Items.Add(sListenIP);
            }

            if (ComboListenIP.Items.Count != 0)
                ComboListenIP.SelectedIndex = 0;
        }
        
        private String ComboGetSelectedListenIP()
        {
            int nSelectedIndex = ComboListenIP.SelectedIndex;

            if (nSelectedIndex == -1)
                return "";

            return (String)ComboListenIP.Items[nSelectedIndex];
        }

        public void OnVaxErrorMsg(String sFuncName, String sErrorMsg, int nErrorCode)
        {
            MessageBox.Show(sErrorMsg, "VaxVoIP SIP SDK", MessageBoxButton.OK, MessageBoxImage.Exclamation);
        }
    }
}
